# -*-makefile-*-
# File:    u95uif.mak
# Comment: This is a hellping makefile is for compiling the sheep library by 
# G95 compiler under Linux and MacOSX
# Intel Fortan under Linux and MacOSX

# You MUST(!) invoke it from u95mak or uif.mak

# sets MATHLINK for specific computer; used for development computers only
### include mathlinkdir.mak


CC    = gcc
MPREP = $(MATHLINK)/mprep
DEL   = rm -f


# ---------------------------------------------------------------------------
#  Choose includes and libraries
# ---------------------------------------------------------------------------

# C includes, needed for mathlink.h
INC = -I"$(MATHLINK)" 

# ---------------------------------------------------------------------------
#  Set  flags
# ---------------------------------------------------------------------------

# Flags for C compiler
#   
# G95_STYLE is needed in MathLinkWrapper.c and is needed in order to set correctly non-capitalisation of C names.
CCFLAGS+= $(INC)  -D$(ABI) -g $(SPECCPP)
# Why SPECCPP : g95 on MacOSX is 32-bit


# Flags for Fortran90 compiler
# -fmod=       where *.mod files placed, they will bin in ./g95/ directory
# -ftrace=     to allow debugging in case of failures
# -fno-second-underscore            do not  append a second trailing underscore in names having an underscore
# F90FLAGS =  -ftrace=full -fcase-upper -fno-second-underscore -fno-underscoring    


# Flags to lib
LIBFLAGS = 

# ---------------------------------------------------------------------------
#  Rules for linking
# ---------------------------------------------------------------------------

# Create a library from the object files.

# Note: We have to start with MathCodePrecision as it creates a module
# file used in MathLinkInterface and MathCodeSheep.

# MathCodeCallback.obj will be included in one of the next releases

all:  $(ABI) $(ABI)/sheep.a

info:
	echo ABI=$(ABI)
$(ABI):
	mkdir  $(ABI)

$(ABI)/sheep.a: $(ABI)/MathCodePrecision.o $(ABI)/MathLinkWrapper.o $(ABI)/MathLinkInterface.o \
	   $(ABI)/MathCodeSheep.o $(ABI)/MathCodeMainUnx.o
	ar rcvs $(LIBFLAGS) $(ABI)/sheep.a $(ABI)/MathLinkWrapper.o $(ABI)/MathLinkInterface.o \
	  $(ABI)/MathCodeSheep.o $(ABI)/MathCodePrecision.o 
# Note that	  
#	   $(ABI)/MathCodeMainUnx.o
# is not collected here. This is because Fortran PROGRAM->C->FORTRAN function
# is not supported by the linker, and symbol _MAIN_ cannot be correctly found.
# Instead the C main() function is placed in MathLinkWrapper.c


# ---------------------------------------------------------------------------
#  Rules for compiling
# ---------------------------------------------------------------------------

$(ABI)/MathLinkWrapper.o: MathLinkWrapper.c
	$(CC) -c $(CCFLAGS) MathLinkWrapper.c -o $(ABI)/MathLinkWrapper.o

$(ABI)/MathLinkCallback.o: MathLinkCallback.c
	$(CC) -c $(CCFLAGS) MathLinkCallback.c -o $(ABI)/MathLinkCallback.o

$(ABI)/MathLinkInterface.o: MathLinkInterface.f90
	$(F90) -c MathLinkInterface.f90 $(F90FLAGSM) -o $(ABI)/MathLinkInterface.o

$(ABI)/MathCodePrecision.o: $(ABI) MathCodePrecision.f90
	$(F90) -c MathCodePrecision.f90 $(F90FLAGSM)  -o $(ABI)/MathCodePrecision.o


$(ABI)/MathCodeSheep.o: MathCodeSheep.f90
	$(F90) -c MathCodeSheep.f90 $(F90FLAGSM) -o $(ABI)/MathCodeSheep.o

$(ABI)/MathCodeMainUnx.o: MathCodeMainUnx.f90
	$(F90) -c MathCodeMainUnx.f90 $(F90FLAGSM) -o $(ABI)/MathCodeMainUnx.o


# ---------------------------------------------------------------------------
#  Rules for cleaning up
# ---------------------------------------------------------------------------

clean:
	-$(DEL) */*.o
	-$(DEL) */*.mod
	-$(DEL) */sheep.a
	-$(DEL) *.o
	-$(DEL) *.mod
	-$(DEL) sheep.a

# ---------------------------------------------------------------------------
#  Suffix rules
# ---------------------------------------------------------------------------

#.f90.obj:
#	$(F90) $(F90FLAGS) -c $*.c /object:$(ABI)/$*.obj
#
#.SUFFIXES: .f90

